#! /usr/local/bin/perl
# Use this script to generate the .maildelivery file of the 
# Singular account with
# perl list2maildelivery.pl singular-user singular-team > ~Singular/.maildelivery
# each time one of singular-user or singular-team changed.
# To updated the actual mailing lists, 
# update the file /usr/mmdf/mjdomo/lists/singular-user with the generated list

if ($ARGV[0] =~ /^-.+/)
{
  print <<EOT;
Usage: list2uname [-h] file1 file2 ...
Purpose: Extract user names from each file given on command-line
         Ouput \$header
	       \$format [for each uname]
	       \$footer
	 to stdout. See beginning of list2maildelivery for customization.
EOT
  exit;
}

####################################################################
#
# customization
#

# replaces %e by email address for each extracted uname
$format = 'from %e pipe ? "/usr/bin/resend singular-team@mathematik.uni-kl.de"';
$header = <<EOT;
# header: put each mail into mailbox of Singular
* - file R "/usr/mail/singular"

EOT

$footer = <<EOT;
# anything with register in the Subject is sent to singular-team, as well
subject register pipe ? "/usr/bin/resend singular-team\@mathematik.uni-kl.de"

# anything not matched yet, is sent to obachman  
* - pipe ? "/usr/bin/resend mschulze\@mathematik.uni-kl.de"

EOT
#
# end customization  
####################################################################
  
print "# .maildeliver automatically generated by 'list2maildelivery " .
  join (" ", @ARGV) . "'\n";
print "# DO NOT EDIT, BUT REGENERATE, if content of arguments changed\n\n";

print "# content of \$header:\n";
print $header;

print "# accepted email addresses \n";
print "# accept all from mathematik.uni-kl.de\n";
print 'from mathematik.uni-kl.de pipe ? "/usr/bin/resend singular-team@mathematik.uni-kl.de"' . "\n";

while (<>)
{
  if (/([\w\.-]+)\@([\w\.-]+)/)
  {
    next if /singular/i;  
    $uname = $1 . '@' . $2;
    $_ = $format;
    s/%e/$uname/;
    print "$_\n";
  }
}

print "\n# content of \$footer:\n";
print $footer;
  
