/****************************************
*  Computer Algebra System SINGULAR     *
****************************************/
/* $Id: mmutil.c,v 1.11.2.2 1999/05/27 13:24:41 obachman Exp $ */

/*
* ABSTRACT:
*/

#define _POSIX_SOURCE 1

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "omalloc.h"
#include "mmprivat.h"

#ifndef ABS
#define ABS(x) ((x)<0?(-(x)):(x))
#endif

#ifdef ALIGN_8
const size_t mm_mcbSizes [MAXLIST] = {   8,  16,  24,  32,
                                        40,  48,  56,  64,
                                        80,  96, 112, 128,
                                       160, 192, 224, 256,
                                       512, 1024 };
#else
const size_t mm_mcbSizes [MAXLIST] = {   8,  12,  16,  20,
                                        24,  28,  32,
                                        40,  48,  56,  64,
                                        80,  96, 112, 128,
                                       160, 192, 224, 256,
                                       512, 1024 };
#endif

#ifndef HAVE_INDEX_TABLE

int mmGetIndex( size_t size )
{
  int j;

#ifdef ALIGN_8
  if (size<81)
  {
    if (size<41)
    {
      if (size<25)
      {
        if(size<17)
        {
          if (size<9) j= 0;
          else        j= 1;
        }
        else /*17..24*/
        {
          j= 2;
        }
      }
      else/*25..40*/
      {
        if(size<33)
        {
          j= 3;
        }
        else /*33..40*/
        {
          j= 4;
        }
      }
    }
    else/*41..80*/
    {
      if(size<57)
      {
        if (size<49) j= 5;
        else         j= 6;
      }
      else /*57..80*/
      {
        if (size<65) j= 7;
        else         j= 8;
      }
    }
  }
  else/*81..1024*/
  {
    if(size<161)
    {
      if (size<113)
      {
        if (size<97) j= 9;
        else         j= 10;
      }
      else /*113..160*/
      {
        if (size<129) j= 11;
        else          j= 12;
      }
    }
    else/*161..1024*/
    {
      if (size<257)
      {
        if (size<225)
        {
          if (size<193)  j= 13;
          else           j= 14;
        }
        else             j= 15;
      }
      else/*257..1024*/
      {
        if(size<1025)
        {
          if(size<513) j= 16;
          else         j= 17;
        }
        else
          j= -1;
      }
    }
  }
#else
  if (size<161)
  {
    if (size<41)
    {
      if (size<21)
      {
        if(size<13)
        {
          if (size<9) j= 0;
          else        j= 1;
        }
        else /*13..20*/
        {
          if (size<17) j= 2;
          else         j= 3;
        }
      }
      else/*21..40*/
      {
        if(size<29)
        {
          if (size<25) j= 4;
          else         j= 5;
        }
        else /*29..40*/
        {
          if (size<33) j= 6;
          else         j= 7;
        }
      }
    }
    else/*41..160*/
    {
      if (size<81)
      {
        if(size<57)
        {
          if (size<49) j= 8;
          else         j= 9;
        }
        else /*57..80*/
        {
          if (size<65) j= 10;
          else         j= 11;
        }
      }
      else/*81..160*/
      {
        if(size<113)
        {
          if (size<97) j= 12;
          else         j= 13;
        }
        else /*113..160*/
        {
          if (size<129) j= 14;
          else          j= 15;
        }
      }
    }
  }
  else/*161..1024*/
  {
    if (size<257)
    {
      if (size<225)
      {
        if (size<193)  j= 16;
        else           j= 17;
      }
      else             j= 18;
    }
    else/*257..1024*/
    {
      if(size<1025)
      {
        if(size<513) j= 19;
        else         j= 20;
      }
      else
        j= -1;
    }
  }
#endif
  return j;
}

#endif /* ! HAVE_INDEX_TABLE */

#ifndef GENERATE_INDEX_TABLE
mcb mmNewMCBList( int i )
{
  char* blk = (char*)mmGetBlock();
  char* top;
  mcb dummy, p;
  size_t offset = mm_mcbSizes[i];

  dummy = (mcb)blk;
  p = dummy;
  top = blk + MAXDATA - offset;
  while ( (char*)p < top )
  {
    *p = (void*)((char*)p + offset);
    p = (mcb)*p;
  }
  *p = NULL;

  return dummy;
}

#ifdef sun
#ifdef __svr4__
void bzero(char *s,int n)
{
  memset(s,0,n);
}
#endif
#endif

#endif /* ! GENERATE_INDEX_TABLE */

#ifdef HAVE_INDEX_TABLE

#ifdef GENERATE_INDEX_TABLE
const size_t mm_mcbSizesAlign8 [] = {   8,  16,  24,  32,
                                       40,  48,  56,  64,
                                       80,  96, 112, 128,
                                      160, 192, 224, 256,
                                      512, 1024 };
const size_t mm_mcbSizesAlign4 [] = {   8,  12,  16,  20,
                                       24,  28,  32,
                                       40,  48,  56,  64,
                                       80,  96, 112, 128,
                                      160, 192, 224, 256,
                                      512, 1024 };

INDEX_ENTRY_T mm_IndiciesAlign8[MAX_INDEX + 1];
INDEX_ENTRY_T mm_IndiciesAlign4[MAX_INDEX + 1];

int mmGetBinaryIndexAlign8( size_t size )
{
  int j;

  if (size<81)
  {
    if (size<41)
    {
      if (size<25)
      {
        if(size<17)
        {
          if (size<9) j= 0;
          else        j= 1;
        }
        else /*17..24*/
        {
          j= 2;
        }
      }
      else/*25..40*/
      {
        if(size<33)
        {
          j= 3;
        }
        else /*33..40*/
        {
          j= 4;
        }
      }
    }
    else/*41..80*/
    {
      if(size<57)
      {
        if (size<49) j= 5;
        else         j= 6;
      }
      else /*57..80*/
      {
        if (size<65) j= 7;
        else         j= 8;
      }
    }
  }
  else/*81..1024*/
  {
    if(size<161)
    {
      if (size<113)
      {
        if (size<97) j= 9;
        else         j= 10;
      }
      else /*113..160*/
      {
        if (size<129) j= 11;
        else          j= 12;
      }
    }
    else/*161..1024*/
    {
      if (size<257)
      {
        if (size<225)
        {
          if (size<193)  j= 13;
          else           j= 14;
        }
        else             j= 15;
      }
      else/*257..1024*/
      {
        if(size<1025)
        {
          if(size<513) j= 16;
          else         j= 17;
        }
        else
          j= -1;
      }
    }
  }
  return j;
}

int mmGetBinaryIndex( size_t size )
{
  int j;
  if (size<161)
  {
    if (size<41)
    {
      if (size<21)
      {
        if(size<13)
        {
          if (size<9) j= 0;
          else        j= 1;
        }
        else /*13..20*/
        {
          if (size<17) j= 2;
          else         j= 3;
        }
      }
      else/*21..40*/
      {
        if(size<29)
        {
          if (size<25) j= 4;
          else         j= 5;
        }
        else /*29..40*/
        {
          if (size<33) j= 6;
          else         j= 7;
        }
      }
    }
    else/*41..160*/
    {
      if (size<81)
      {
        if(size<57)
        {
          if (size<49) j= 8;
          else         j= 9;
        }
        else /*57..80*/
        {
          if (size<65) j= 10;
          else         j= 11;
        }
      }
      else/*81..160*/
      {
        if(size<113)
        {
          if (size<97) j= 12;
          else         j= 13;
        }
        else /*113..160*/
        {
          if (size<129) j= 14;
          else          j= 15;
        }
      }
    }
  }
  else/*161..1024*/
  {
    if (size<257)
    {
      if (size<225)
      {
        if (size<193)  j= 16;
        else           j= 17;
      }
      else             j= 18;
    }
    else/*257..1024*/
    {
      if(size<1025)
      {
        if(size<513) j= 19;
        else         j= 20;
      }
      else
        j= -1;
    }
  }
  return j;
}

int GetIndex(size_t size, const size_t* size_table)
{
  int i;

  if (size > MAX_BLOCK_SIZE)
  {
    printf("GetIndex: %d size is too large\n", size);
    exit(1);
  }

  for (i=0; size_table[i] < size; i++)
  {};

  return i;
}


void mmInitIndexTable(INDEX_ENTRY_T* index_table, const size_t* size_table,
                      int (*GetIndexFnc)(size_t size))
{
  unsigned int i;

  /* Fill in IndexTable */
  for (i=0; i<=MAX_INDEX; i++)
    index_table[i] = GetIndex((size_t) i*4 + 1, size_table);

  /* Check what we did */
  if (GetIndexFnc != NULL)
  {
    for (i=1; i<=MAX_BLOCK_SIZE + 5; i++)
    {
      unsigned int t_index, b_index;
      t_index = (i <= MAX_BLOCK_SIZE ? index_table[(i-1) >> 2] : -1);
      b_index = GetIndexFnc(i);

      if (t_index != b_index)
      {
        fprintf(stderr, "Error in mmInitIndexTable for size %d\n", i);
        GetIndexFnc(i);
        exit(1);
      }
    }
  }
}

void OutputIndexTable(INDEX_ENTRY_T* index_table)
{
  int i;
  int l=0;
  printf("const INDEX_ENTRY_T mm_IndexTable[/*%d*/] = {\n",MAX_INDEX+1);
  for (i=0;i<MAX_INDEX; i++,l++)
  {
    printf("%d,", index_table[i]);
    if (l==15) { printf("\n"); l=0; }
  }
  printf("%d};\n", index_table[MAX_INDEX]);
}


int main()
{
  mmInitIndexTable(mm_IndiciesAlign8, mm_mcbSizesAlign8,
                   mmGetBinaryIndexAlign8);
  mmInitIndexTable(mm_IndiciesAlign4, mm_mcbSizesAlign4,
                   mmGetBinaryIndex);

  printf("#ifdef ALIGN_8\n");
  OutputIndexTable(mm_IndiciesAlign8);
  printf("#else\n");
  OutputIndexTable(mm_IndiciesAlign4);
  printf("#endif");
  return 0;
}

#else /* ! GENERATE_INDEX_TABLE */

#include"mmutil.inc"

#endif /* GENERATE_INDEX_TABLE */
#endif /* HAVE_INDEX_TABLE */
